/* $Id: chpwdfile.h 1.9 Tue, 15 May 2001 15:52:33 +0200 warwick $ */
/* Header file for chpwdfile */

/* Defaults */
#define DEFAULTCONFFILE "/etc/chpwdfile.conf"
#define DEFAULTHASH 'd'	/* DES encryption */
#define DEFAULTOPERATION 'm'	/* modify user entry */
#define DEFAULTMINUSER 3	/* minimum username length */
#define DEFAULTMINPASSWD 5	/* minumum password length */

/* The name of the admin (root) user */
#define ADMIN "admin"

/* Names of the CGI variables we expect */
#ifdef CGI
#define CGIUSERNAME "username"
#define CGIOLDPASS "oldpasswd"	/* admin or user's existing one */
#define CGINEWPASS1 "newpasswd1"	/* first attempt typing new passwd */
#define CGINEWPASS2 "newpasswd2"	/* second attempt typing new passwd */
#endif	/* CGI */

/* Some maxima; don't know about that line length one */
#define MAXFILENAMELENGTH 128
#define MAXUSERLENGTH 128
#define MAXPASSWORDLENGTH 128
#define MAXLINELENGTH \
	((MAXUSERLENGTH)+(MAXPASSWORDLENGTH)+(MAXFILENAMELENGTH)+(1))

/* How many times we try to lock the passwd file before giving up */
#define MAXLOCKTRIES 3

/* Where do we read random data from a byte at a time? */
#define RANDOMSOURCE "/dev/urandom"

/* Error codes */
#define BADHASHTYPE 1
#define MINPASSWORDTOOBIG 2
#define MINUSERTOOBIG 3
#define BADCALL 4
#define NOCONFFILE 5
#define BADCONFFILE 6
#define USERNOTFOUND 7
#define USEREXISTS 8
#define NOAUTHENTICATE 9
#define BADPASSWORD 10
#define BADLOCK 11
#define BADTMP 12
#define NOPASSWDFILE 13
#define BADUSERNAME 14
#define BADOPERATION 15
#define FILEPERMERR 16
#define BADPATH 18
#define NORANDOM 19
#define SHOWVERSION 254
#define GETHELP 255

/* Function prototypes */
extern int user_search(char *file, char *user);
extern int add_user(int minpasswd, int authenticate);
extern int delete_user(int authenticate);
extern int modify_user(int minpassw, int authenticate);
extern int read_config(FILE *confstream, int *minpasswd, int *minuser);
extern void print_usage(char *basename, int err);
extern int read_new_passwds(char *newpasswd1, char *newpasswd2, int maxlength);

